﻿SystemOrganization addCategory: #'Neo4reSt-Squeak-Core'!
SystemOrganization addCategory: #'Neo4reSt-Tests'!
SystemOrganization addCategory: #'Neo4reSt-Core'!
SystemOrganization addCategory: #'Neo4reSt-Traversal'!
SystemOrganization addCategory: #'Neo4reSt-IndexModel'!
SystemOrganization addCategory: #'Neo4reSt-GraphModel'!
SystemOrganization addCategory: #'Neo4reSt-Demo-Dumper'!
SystemOrganization addCategory: #'Neo4reSt-Cypher'!
SystemOrganization addCategory: #'Neo4reSt-Client'!

!WebClient methodsFor: '*Neo4reSt-Squeak-Core' stamp: 'mu 2/17/2012 00:12'!
jsonDelete: urlString
		| request |
	self initializeFromUrl: urlString urlEncoded.
	request := self newJsonRequest initializeFromUrl: urlString urlEncoded.
	request method: 'DELETE'.
	userAgent ifNotNil:[request headerAt: 'User-Agent' put: userAgent].
	^self sendRequest: request! !

!WebClient methodsFor: '*Neo4reSt-Squeak-Core' stamp: 'mu 2/17/2012 00:11'!
jsonGet: urlString
	| request |
	self initializeFromUrl: urlString.
	request := self newJsonRequest initializeFromUrl: urlString urlEncoded.
	request method: 'GET'.
	userAgent ifNotNil:[request headerAt: 'User-Agent' put: userAgent].
	^self sendRequest: request
! !

!WebClient methodsFor: '*Neo4reSt-Squeak-Core' stamp: 'mu 2/17/2012 00:11'!
jsonPost: urlString
		| request |
	self initializeFromUrl: urlString.
	request := (self newJsonRequest initializeFromUrl: urlString urlEncoded) forSendData.
	request method: 'POST'.
	userAgent ifNotNil:[request headerAt: 'User-Agent' put: userAgent].
	^self sendRequest: request content: '' readStream size: 0! !

!WebClient methodsFor: '*Neo4reSt-Squeak-Core' stamp: 'mu 2/17/2012 00:12'!
jsonPost: urlString content: jsonString
	| request |
	self initializeFromUrl: urlString urlEncoded.
	request := (self newJsonRequest initializeFromUrl: urlString urlEncoded) forSendData.
	request method: 'POST'.
	request headerAt: 'Content-Length' put: jsonString size.
	userAgent ifNotNil:[request headerAt: 'User-Agent' put: userAgent].
	^self sendRequest: request content: jsonString readStream size: jsonString size! !

!WebClient methodsFor: '*Neo4reSt-Squeak-Core' stamp: 'mu 2/17/2012 00:12'!
jsonPut: urlString content: jsonString
	| request |
	self initializeFromUrl: urlString urlEncoded.
	request := (self newJsonRequest initializeFromUrl: urlString urlEncoded) forSendData.
	request method: 'PUT'.
	request headerAt: 'Content-Length' put: jsonString size.
	userAgent ifNotNil:[request headerAt: 'User-Agent' put: userAgent].
	^self sendRequest: request content: jsonString readStream size: jsonString size! !

!WebClient methodsFor: '*Neo4reSt-Squeak-Core' stamp: 'mu 11/27/2011 15:28'!
newJsonRequest
	^ N4WebJsonRequest new! !

WebRequest subclass: #N4WebJsonRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Squeak-Core'!

!N4WebJsonRequest methodsFor: 'initialize' stamp: 'mu 11/27/2011 17:14'!
forSendData
	self headerAt: 'Content-Type' put: 'application/json; charset=utf-8'.! !

!N4WebJsonRequest methodsFor: 'initialize' stamp: 'mu 11/27/2011 15:37'!
initialize
	super initialize.
	self headerAt: 'Accept' put: 'application/json'.! !

!N4WebJsonRequest methodsFor: 'initialize' stamp: 'mu 11/27/2011 15:33'!
newResponse
	"Create a new response entitiy.
	Subclasses can override this method to provide a different response class"

	^(N4WebJsonResponse new)
		request: self;
		yourself! !

Dictionary subclass: #N4Dictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Core'!

WebResponse subclass: #N4WebJsonResponse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Squeak-Core'!

!N4WebJsonResponse methodsFor: 'location-accessing' stamp: 'mu 12/9/2011 00:49'!
location
	^self headerAt: 'location' ifAbsent: []! !

!N4WebJsonResponse methodsFor: 'initialize' stamp: 'mu 12/7/2011 00:28'!
readFrom: aStream
	"Parse an HTTP response from the given stream"
	
	| space |
	stream := aStream.
	stream upToAll: 'HTTP/'.
	space := Character space.
	protocol := 'HTTP/', (stream upTo: space).
	code := [(stream upTo: space) asNumber] on: Error do: [^ self error:'Invalid response: ', stream upToEnd].
	status := code printString, ' ', (stream upToAll: String crlf).
	
	headers := WebUtils readHeadersFrom: stream.
! !

Error subclass: #N4Error
	instanceVariableNames: 'properties response'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Core'!

N4Error subclass: #N4CannotDelete
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Core'!

!N4Error class methodsFor: 'instance creation' stamp: 'mu 11/27/2011 22:02'!
properties: assocs
	^self new properties: assocs! !

!N4Error class methodsFor: 'instance creation' stamp: 'mu 11/27/2011 22:22'!
response: response
	^self new response: response! !

!N4Error methodsFor: 'accessing' stamp: 'mu 11/27/2011 22:01'!
properties
	"Answer the value of properties"

	^ properties! !

!N4Error methodsFor: 'accessing' stamp: 'mu 11/27/2011 22:01'!
properties: anObject
	"Set the value of properties"

	properties := anObject! !

!N4Error methodsFor: 'accessing' stamp: 'mu 11/27/2011 22:22'!
response
	"Answer the value of response"

	^ response! !

!N4Error methodsFor: 'accessing' stamp: 'mu 11/27/2011 22:22'!
response: anObject
	"Set the value of response"

	response := anObject! !

N4Error subclass: #N4NoContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Core'!

N4Error subclass: #N4NotFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Core'!

TestCase subclass: #N4GraphModelTest
	instanceVariableNames: 'db initialNodeForTest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Tests'!

!N4GraphModelTest commentStamp: 'mu 2/13/2012 01:01' prior: 0!
self suite run!

!N4GraphModelTest methodsFor: 'running' stamp: 'mu 2/13/2012 00:28'!
setUp
	| initialNode |
	db := N4GraphDb new.
	[initialNode := db initialNode] on: Error do: [:ex |
		self error: 'Neo4j is running? ', ex description printString].

	(initialNode outgoing: 'N4GraphModelTest') do: [:each | each delete].

	initialNodeForTest := initialNode relateToNewNode: 'N4GraphModelTest'
	
! !

!N4GraphModelTest methodsFor: 'testing' stamp: 'mu 2/13/2012 00:58'!
testBasicCreateNodes
	"self debug: #testBasicCreateNodes"
		
	| node1 node2 relation1 |
	node1 := db createNode.
	node2 := db createNode.
	relation1 := node1 relateTo: node2 type: #follows.
	
	self assert: ((node1 incoming) size = 0).
	initialNodeForTest relateTo: node1 type: #testBasicCreateNodes.
	self assert: ((node1 incoming) size = 1).

	self assert: ((initialNodeForTest outgoing: #testBasicCreateNodes) size = 1).
	self assert: ((node1 allRelationships) size = 2).
	self assert: ((node2 allRelationships) size = 1).
	
	self assert: ((node1 outgoing) size = 1).
	self assert: ((node2 incoming) size = 1).
	
	self assert: (relation1 id = node1 outgoing first id).
	self assert: (relation1 id = node2 incoming first id).
	
	(initialNodeForTest outgoing: #testBasicCreateNodes) first delete.
	
	self assert: ((node1 incoming) size = 0).

! !

!N4GraphModelTest methodsFor: 'testing' stamp: 'mu 2/16/2012 23:36'!
testBasicCreateNodesWithProperties
	"self debug: #testBasicCreateNodesWithProperties"
		
	| node1 node2 relation1 |
	node1 := db createNode: (#name-> 'start').
	node2 := db createNode: (#name-> 'end').
	relation1 := node1 relateTo: node2 type: #follows properties: (#score->100).
	
	self assert: ((node1 incoming) size = 0).
	initialNodeForTest relateTo: node1 type: #testBasicCreateNodesWithProperties.
	self assert: ((node1 incoming) size = 1).

	self assert: ((initialNodeForTest outgoing: #testBasicCreateNodesWithProperties) size = 1).
		
	self assert: ((node1 propertyAt: #name) = 'start').
	self assert: ((node2 propertyAt: #name) = 'end').
	self assert: ((relation1 propertyAt: #score) = 100).
	
	self assert: (node1 properties size = 1).
	node1 propertyAt: #name put: 'START'.
	self assert: ((node1 propertyAt: #name) = 'START').

	self assert: (relation1 properties size = 1).
	relation1 propertyAt: #score put: ((relation1 propertyAt: #score) + 200).
	self assert: ((relation1 propertyAt: #score) = 300).
	
	node2 propertyAt: #address put: 'Tokyo'.
	self assert: (node2 properties size = 2).
	
	node1 removePropertyAt: #name.
	node2 removePropertyAt: #name.
	relation1 removePropertyAt: #score.
	
	self assert: (node1 properties size = 0).
	self assert: (node2 properties size = 1).
	self assert: (relation1 properties size = 0).
	
	(initialNodeForTest outgoing: #testBasicCreateNodesWithProperties) first delete.
	
	self assert: ((node1 incoming) size = 0).

! !

!N4GraphModelTest methodsFor: 'testing' stamp: 'mu 2/19/2012 21:11'!
testBasicIndexers
	"self debug: #testBasicIndexers"
		
	| node1 node2 relation1 detectedNode1 detectedNode2 detectedRel1 |
	node1 := db createNode: (#name-> 'Masashi Umezawa').
	node2 := db createNode: (#name-> 'Smalltalk').
	relation1 := node1 relateTo: node2 type: #users properties: (#years->18).
	
	self assert: ((node1 incoming) size = 0).
	initialNodeForTest relateTo: node1 type: #testBasicIndexers.
	self assert: ((initialNodeForTest outgoing: #testBasicIndexers) size = 1).
	
	(db nodeIndexesNamed: 'people') addKey: #initial value: 'mu' for: node1.
	(db nodeIndexesNamed: 'programming languages') addKey: #extension value: 'st' for: node2.
	(db relationshipIndexesNamed: 'favorites') addKey: #rating value: 100 for: relation1.

	detectedNode1 := (db nodeIndexesNamed: 'people') detectWith: (#initial -> 'mu').
	detectedNode2 := (db nodeIndexesNamed: 'programming languages') detectWith: (#extension -> 'st').
	detectedRel1 := (db relationshipIndexesNamed: 'favorites') detectWith: (#rating -> 100).
	
	self assert: (node1 = detectedNode1).
	self assert: (node2 = detectedNode2).
	self assert: (relation1 = detectedRel1).
	
	(db nodeIndexesNamed: 'people') removeAllFor: node1.
	(db nodeIndexesNamed: 'programming languages') removeAllFor: node2.
	(db relationshipIndexesNamed: 'favorites') removeAllFor: relation1.
	
	(db nodeIndexesNamed: 'people') delete.
	(db nodeIndexesNamed: 'programming languages') delete.
	(db relationshipIndexesNamed: 'favorites') delete.
	
	(initialNodeForTest outgoing: #testBasicIndexers) first delete.
	
	self assert: ((node1 incoming) size = 0).

! !

Object subclass: #N4CypherResponse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Cypher'!

N4CypherResponse subclass: #N4CypherErrorReport
	instanceVariableNames: 'message exception stackTrace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Cypher'!

!N4CypherErrorReport class methodsFor: 'instance creation' stamp: 'mu 2/5/2012 16:40'!
json: jsonObject
	| inst |
	inst := self new.
	inst message: (jsonObject at: 'message').
	inst exception: (jsonObject at: 'exception').
	inst stackTrace: (jsonObject at: 'stackTrace').
	^inst! !

!N4CypherErrorReport methodsFor: 'accessing' stamp: 'mu 2/5/2012 16:35'!
exception
	"Answer the value of exception"

	^ exception! !

!N4CypherErrorReport methodsFor: 'accessing' stamp: 'mu 2/5/2012 16:35'!
exception: anObject
	"Set the value of exception"

	exception := anObject! !

!N4CypherErrorReport methodsFor: 'accessing' stamp: 'mu 2/5/2012 16:35'!
message
	"Answer the value of message"

	^ message! !

!N4CypherErrorReport methodsFor: 'accessing' stamp: 'mu 2/5/2012 16:35'!
message: anObject
	"Set the value of message"

	message := anObject! !

!N4CypherErrorReport methodsFor: 'accessing' stamp: 'mu 2/5/2012 16:35'!
stackTrace
	"Answer the value of stackTrace"

	^ stackTrace! !

!N4CypherErrorReport methodsFor: 'accessing' stamp: 'mu 2/5/2012 16:35'!
stackTrace: anObject
	"Set the value of stackTrace"

	stackTrace := anObject! !

!N4CypherResponse class methodsFor: 'instance creation' stamp: 'mu 2/5/2012 16:38'!
json: jsonObject
	! !

N4CypherResponse subclass: #N4CypherResult
	instanceVariableNames: 'columns data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Cypher'!

!N4CypherResult class methodsFor: 'instance creation' stamp: 'mu 2/5/2012 16:39'!
json: jsonObject
	| inst |
	inst := self new.
	inst columns: (jsonObject at: 'columns').
	inst data: (jsonObject at: 'data').
	^inst! !

!N4CypherResult methodsFor: 'accessing' stamp: 'mu 2/6/2012 23:33'!
columns
	"Answer the value of columns"

	^ columns ifNil: [columns := #()]! !

!N4CypherResult methodsFor: 'accessing' stamp: 'mu 2/5/2012 16:35'!
columns: anObject
	"Set the value of columns"

	columns := anObject! !

!N4CypherResult methodsFor: 'enumeration' stamp: 'mu 2/6/2012 23:44'!
columnsAndDataDo: aBlock
	| clms |
	clms := self columns.
	self data do: [:eachRow |
		1 to: clms size do: [:idx |
			aBlock value: (clms at: idx) value: (eachRow at: idx).	
		]
	]! !

!N4CypherResult methodsFor: 'accessing' stamp: 'mu 2/6/2012 23:33'!
data
	"Answer the value of data"

	^ data ifNil: [data := #()]! !

!N4CypherResult methodsFor: 'accessing' stamp: 'mu 2/5/2012 16:35'!
data: anObject
	"Set the value of data"

	data := anObject! !

!N4CypherResult methodsFor: 'enumeration' stamp: 'mu 2/6/2012 23:33'!
dataDo: aBlock
	^ self data do: aBlock! !

!N4CypherResult methodsFor: 'enumeration' stamp: 'mu 2/6/2012 23:34'!
do: aBlock
	^ self dataDo: aBlock! !

Object subclass: #N4GraphObject
	instanceVariableNames: 'db restClient id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-GraphModel'!

N4GraphObject subclass: #N4GraphDb
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-GraphModel'!

!N4GraphDb methodsFor: 'actions' stamp: 'mu 12/24/2011 23:31'!
createNode
	^ (N4Node from: self restClient createNode) db: self! !

!N4GraphDb methodsFor: 'actions' stamp: 'mu 12/24/2011 23:31'!
createNode: properties
	^ (N4Node from: (self restClient createNode: properties)) db: self! !

!N4GraphDb methodsFor: 'printing' stamp: 'mu 12/24/2011 15:30'!
elementName
	^'db'! !

!N4GraphDb methodsFor: 'accessing' stamp: 'mu 12/21/2011 00:45'!
indexer
	^ N4Indexer on: self! !

!N4GraphDb methodsFor: 'actions' stamp: 'mu 12/23/2011 13:11'!
initialNode
	^self nodeAt: 0! !

!N4GraphDb methodsFor: 'actions' stamp: 'mu 12/24/2011 23:30'!
nodeAt: id 
	| resp |
	resp := self restClient getNodeAt: id.
	resp code = 200
		ifTrue: [^ (N4Node id: id) db: self]! !

!N4GraphDb methodsFor: 'indexing' stamp: 'mu 2/16/2012 23:56'!
nodeIndexesNamed: indexName
	^self indexer nodeIndexesNamed: indexName! !

!N4GraphDb methodsFor: 'printing' stamp: 'mu 12/24/2011 15:29'!
printElementHeaderOn: aStream
	aStream nextPutAll: self elementName.
	aStream nextPut: $[.
	aStream nextPutAll: self restClient rootUri.
	aStream nextPut: $]
	! !

!N4GraphDb methodsFor: 'actions' stamp: 'mu 2/5/2012 16:43'!
queryByCypher: queryString
	^N4CypherResult json: (self restClient queryByCypher: queryString)! !

!N4GraphDb methodsFor: 'actions' stamp: 'mu 12/24/2011 23:30'!
relationshipAt: id 
	| resp |
	resp := self restClient getRelationshipAt: id.
	resp code = 200
		ifTrue: [^ (N4Relationship id: id) db: self]
	! !

!N4GraphDb methodsFor: 'indexing' stamp: 'mu 2/16/2012 23:56'!
relationshipIndexesNamed: indexName
	^self indexer relationshipIndexesNamed: indexName! !

!N4GraphDb methodsFor: 'actions' stamp: 'mu 12/13/2011 23:22'!
relationshipTypes
	^ self restClient getRelationshipTypes! !

!N4GraphObject class methodsFor: 'instance creation' stamp: 'mu 2/19/2012 21:21'!
db: aGraphDb
	| inst |
	inst := self new.
	inst db: aGraphDb.
	^inst! !

!N4GraphObject class methodsFor: 'instance creation' stamp: 'mu 12/13/2011 23:31'!
from: response
	^self id: (self portableUtil pickIdFrom: response location).
	! !

!N4GraphObject class methodsFor: 'instance creation' stamp: 'mu 12/13/2011 23:50'!
id: anInteger 
	| inst |
	inst := self new.
	inst id: anInteger asInteger.
	^inst! !

!N4GraphObject class methodsFor: 'instance creation' stamp: 'mu 12/13/2011 23:53'!
json: jsonObject
	^self new
	! !

!N4GraphObject class methodsFor: 'accessing' stamp: 'mu 12/9/2011 00:42'!
portableUtil
	^N4PortableUtil default! !

!N4GraphObject methodsFor: 'compareing' stamp: 'mu 2/17/2012 00:03'!
= other
	^ self class = other class and: [self id = other id]! !

!N4GraphObject methodsFor: 'properties' stamp: 'mu 12/23/2011 13:38'!
at: propName 
	"shortcut"
	^self propertyAt: propName! !

!N4GraphObject methodsFor: 'properties' stamp: 'mu 12/23/2011 13:38'!
at: propName put: value
	"shortcut"
	^self propertyAt: propName put: value! !

!N4GraphObject methodsFor: 'accessing' stamp: 'mu 12/24/2011 23:26'!
db
	"Answer the value of db"

	^ db! !

!N4GraphObject methodsFor: 'accessing' stamp: 'mu 12/24/2011 23:26'!
db: anObject
	"Set the value of db"

	db := anObject! !

!N4GraphObject methodsFor: 'printing' stamp: 'mu 12/24/2011 15:18'!
elementName
	^self class name! !

!N4GraphObject methodsFor: 'compareing' stamp: 'mu 2/17/2012 00:03'!
hash
	^self id hash! !

!N4GraphObject methodsFor: 'accessing' stamp: 'mu 12/9/2011 00:36'!
id
	"Answer the value of id"

	^ id! !

!N4GraphObject methodsFor: 'accessing' stamp: 'mu 12/9/2011 00:36'!
id: anObject
	"Set the value of id"

	id := anObject! !

!N4GraphObject methodsFor: 'printing' stamp: 'mu 12/24/2011 15:20'!
printElementHeaderOn: aStream
	aStream nextPutAll: self elementName.
	aStream nextPut: $[.
	aStream nextPutAll: self id printString.
	aStream nextPut: $]
	! !

!N4GraphObject methodsFor: 'printing' stamp: 'mu 12/24/2011 15:20'!
printOn: aStream
	self printElementHeaderOn: aStream! !

!N4GraphObject methodsFor: 'properties' stamp: 'mu 12/10/2011 23:39'!
properties! !

!N4GraphObject methodsFor: 'properties' stamp: 'mu 12/10/2011 23:39'!
properties: propAssocs! !

!N4GraphObject methodsFor: 'properties' stamp: 'mu 12/10/2011 23:41'!
propertyAt: propName ! !

!N4GraphObject methodsFor: 'properties' stamp: 'mu 12/10/2011 23:41'!
propertyAt: propName put: value! !

!N4GraphObject methodsFor: 'properties' stamp: 'mu 12/13/2011 23:08'!
removePropertyAt: propName! !

!N4GraphObject methodsFor: 'accessing' stamp: 'mu 12/8/2011 23:58'!
restClient

	^ restClient ifNil: [restClient := N4RestClient new]! !

!N4GraphObject methodsFor: 'accessing' stamp: 'mu 12/8/2011 23:57'!
restClient: anObject
	"Set the value of restClient"

	restClient := anObject! !

N4GraphObject subclass: #N4Node
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-GraphModel'!

!N4Node class methodsFor: 'instance creation' stamp: 'mu 12/24/2011 23:04'!
json: jsonObject
	| inst |
	inst := self new.
	inst id: (self portableUtil pickIdFrom: (jsonObject at: 'self')).
	inst properties: (jsonObject at: 'data').
	^inst! !

!N4Node methodsFor: 'traversal' stamp: 'mu 1/22/2012 15:13'!
all: type
	^self traversal returnRelationship relAll: type! !

!N4Node methodsFor: 'accessing-relationships' stamp: 'mu 12/23/2011 13:15'!
allRelationships
	| jsons |
	jsons := self restClient getAllRelationshipsAt: self id.
	^jsons collect: [:each | N4Relationship json: each for: self]! !

!N4Node methodsFor: 'accessing-relationships' stamp: 'mu 12/23/2011 13:33'!
allRelationships: type
	| jsons |
	jsons := self restClient getAllRelationshipsAt: self id type: type.
	^jsons collect: [:each | N4Relationship json: each for: self]! !

!N4Node methodsFor: 'actions' stamp: 'mu 12/13/2011 23:01'!
delete
	^ self restClient deleteNodeAt: self id ! !

!N4Node methodsFor: 'printing' stamp: 'mu 12/24/2011 15:19'!
elementName
	^'node'! !

!N4Node methodsFor: 'accessing-relationships' stamp: 'mu 12/23/2011 13:15'!
inRelationships
	| jsons |
	jsons := self restClient getInRelationshipsAt: self id.
	^jsons collect: [:each | N4Relationship json: each for: self]! !

!N4Node methodsFor: 'accessing-relationships' stamp: 'mu 12/23/2011 13:33'!
inRelationships: type
	| jsons |
	jsons := self restClient getInRelationshipsAt: self id type: type.
	^jsons collect: [:each | N4Relationship json: each for: self]! !

!N4Node methodsFor: 'accessing-relationships' stamp: 'mu 12/23/2011 13:26'!
incoming
	^self inRelationships! !

!N4Node methodsFor: 'traversal' stamp: 'mu 1/22/2012 15:13'!
incoming: type
	^self traversal returnRelationship relIn: type! !

!N4Node methodsFor: 'accessing-relationships' stamp: 'mu 12/23/2011 13:15'!
outRelationships
	| jsons |
	jsons := self restClient getOutRelationshipsAt: self id.
	^jsons collect: [:each | N4Relationship json: each for: self]! !

!N4Node methodsFor: 'accessing-relationships' stamp: 'mu 12/23/2011 13:32'!
outRelationships: type
	| jsons |
	jsons := self restClient getOutRelationshipsAt: self id type: type.
	^jsons collect: [:each | N4Relationship json: each for: self]! !

!N4Node methodsFor: 'accessing-relationships' stamp: 'mu 12/23/2011 13:13'!
outgoing
	^self outRelationships! !

!N4Node methodsFor: 'traversal' stamp: 'mu 1/22/2012 15:13'!
outgoing: type
	^self traversal returnRelationship relOut: type! !

!N4Node methodsFor: 'properties' stamp: 'mu 12/10/2011 23:42'!
properties
	^ self restClient getPropertiesNodeAt: self id ! !

!N4Node methodsFor: 'properties' stamp: 'mu 12/10/2011 23:43'!
properties: propAssocs
	^ self restClient setProperties: propAssocs nodeAt: self id! !

!N4Node methodsFor: 'properties' stamp: 'mu 12/10/2011 23:41'!
propertyAt: propName
	^ self restClient getProperty: propName nodeAt: self id ! !

!N4Node methodsFor: 'properties' stamp: 'mu 12/10/2011 23:41'!
propertyAt: propName put: value
	^ self restClient setProperty: propName to: value nodeAt: self id ! !

!N4Node methodsFor: 'relationships' stamp: 'mu 12/25/2011 22:31'!
relateTo: otherNode type: typeName
	| resp relationship |
	resp :=  self restClient createRelationshipAt: self id to: otherNode uri type: typeName.
	relationship :=(N4Relationship from: resp) db: self.
	relationship type: typeName.	
	relationship startNodeId: self id.
	relationship endNodeId: otherNode id.
	relationship direction: #out.
	^relationship! !

!N4Node methodsFor: 'relationships' stamp: 'mu 12/25/2011 22:31'!
relateTo: otherNode type: typeName properties: assocs
	| resp relationship |
	resp :=  self restClient createRelationshipAt: self id to: otherNode uri type: typeName properties: assocs.
	relationship :=(N4Relationship from: resp) db: self db.
	relationship type: typeName.	
	relationship properties: assocs.	
	relationship startNodeId: self id.
	relationship endNodeId: otherNode id.
	relationship direction: #out.
	^relationship! !

!N4Node methodsFor: 'relationships' stamp: 'mu 2/13/2012 00:16'!
relateToNewNode: typeName 
	| newNode |
	newNode := self db createNode.
	self relateTo: newNode type: typeName.
	^newNode! !

!N4Node methodsFor: 'relationships' stamp: 'mu 2/13/2012 00:21'!
relateToNewNode: typeName nodePropertues: nodePropertues relationshipProperties: relProperties
	| newNode |
	newNode := self db createNode: nodePropertues.
	self relateTo: newNode type: typeName properties: relProperties.
	^newNode! !

!N4Node methodsFor: 'properties' stamp: 'mu 12/13/2011 23:07'!
removePropertyAt: propName
	^ self restClient deleteProperty: propName nodeAt: self id ! !

!N4Node methodsFor: 'traversal' stamp: 'mu 1/22/2012 12:36'!
traversal
	^ N4Traversal from: self! !

!N4Node methodsFor: 'traversal' stamp: 'mu 1/22/2012 15:37'!
traversal: settingBlock
	| trav |
	trav := N4Traversal from: self.
	settingBlock value: trav.
	^trav! !

!N4Node methodsFor: 'accessing' stamp: 'mu 1/22/2012 15:04'!
types
	^ (self allRelationships collect: [:each | each type]) asSet! !

!N4Node methodsFor: 'accessing' stamp: 'mu 12/13/2011 23:43'!
uri
	^ self restClient rootUri, 'node/', self id! !

N4GraphObject subclass: #N4Relationship
	instanceVariableNames: 'type direction startNodeId endNodeId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-GraphModel'!

!N4Relationship class methodsFor: 'instance creation' stamp: 'mu 12/11/2011 00:12'!
from: response
	| inst |
	inst := super from: response.
	
	^inst! !

!N4Relationship class methodsFor: 'instance creation' stamp: 'mu 2/19/2012 21:17'!
json: jsonObject
	| inst |
	inst := self new.
	inst id: (self portableUtil pickIdFrom: (jsonObject at: 'self')).
	inst type: (jsonObject at: 'type').
	inst startNodeId: (self portableUtil pickIdFrom: (jsonObject at: 'start')). 
	inst endNodeId: (self portableUtil pickIdFrom: (jsonObject at: 'end')). 
	
	^inst! !

!N4Relationship class methodsFor: 'instance creation' stamp: 'mu 1/22/2012 14:51'!
json: jsonObject for: startNode
	| inst |
	inst := self new.
	inst id: (self portableUtil pickIdFrom: (jsonObject at: 'self')).
	inst type: (jsonObject at: 'type').
	inst startNodeId: (self portableUtil pickIdFrom: (jsonObject at: 'start')). 
	inst endNodeId: (self portableUtil pickIdFrom: (jsonObject at: 'end')). 
	inst direction: ((inst startNodeId = startNode id) ifTrue: [#out] ifFalse: [#in]). 
	inst db: startNode db.
	^inst! !

!N4Relationship class methodsFor: 'instance creation' stamp: 'mu 12/10/2011 23:54'!
typed: typeName! !

!N4Relationship class methodsFor: 'instance creation' stamp: 'mu 12/10/2011 23:54'!
typed: typeName properties: props! !

!N4Relationship methodsFor: 'actions' stamp: 'mu 12/13/2011 23:01'!
delete
	^ self restClient deleteRelationshipAt: self id ! !

!N4Relationship methodsFor: 'accessing' stamp: 'mu 12/11/2011 00:14'!
direction
	"Answer the value of direction"

	^ direction! !

!N4Relationship methodsFor: 'accessing' stamp: 'mu 12/11/2011 00:14'!
direction: anObject
	"Set the value of direction"

	direction := anObject! !

!N4Relationship methodsFor: 'printing' stamp: 'mu 12/24/2011 15:19'!
elementName
	^'rel'! !

!N4Relationship methodsFor: 'accessing' stamp: 'mu 12/24/2011 23:24'!
endNode
	^ self db nodeAt: self endNodeId! !

!N4Relationship methodsFor: 'accessing' stamp: 'mu 12/14/2011 00:01'!
endNodeId
	"Answer the value of endNodeId"

	^ endNodeId! !

!N4Relationship methodsFor: 'accessing' stamp: 'mu 12/14/2011 00:01'!
endNodeId: anObject
	"Set the value of endNodeId"

	endNodeId := anObject! !

!N4Relationship methodsFor: 'printing' stamp: 'mu 12/24/2011 15:21'!
printOn: aStream
	self printElementHeaderOn: aStream.
	aStream space.
	aStream nextPut: $(.
	aStream nextPutAll: self startNodeId asString.
	aStream nextPut: $).
	aStream space.
	self direction == #in ifTrue: [aStream nextPut: $<].
	aStream nextPut: $-.
	aStream nextPutAll: self type asString.
	aStream nextPut: $-.
	self direction == #out ifTrue: [aStream nextPut: $>].
	aStream space.
	aStream nextPut: $(.
	aStream nextPutAll: self endNodeId asString.
	aStream nextPut: $).! !

!N4Relationship methodsFor: 'properties' stamp: 'mu 12/10/2011 23:44'!
properties
	^ self restClient getPropertiesRelationshipAt: self id ! !

!N4Relationship methodsFor: 'properties' stamp: 'mu 12/10/2011 23:44'!
properties: propAssocs
	^ self restClient setProperties: propAssocs relationshipAt: self id! !

!N4Relationship methodsFor: 'properties' stamp: 'mu 12/10/2011 23:44'!
propertyAt: propName
	^ self restClient getProperty: propName relationshipAt: self id ! !

!N4Relationship methodsFor: 'properties' stamp: 'mu 12/10/2011 23:44'!
propertyAt: propName put: value
	^ self restClient setProperty: propName to: value relationshipAt: self id ! !

!N4Relationship methodsFor: 'properties' stamp: 'mu 12/13/2011 23:08'!
removePropertyAt: propName
	^ self restClient deleteProperty: propName relationshipAt: self id ! !

!N4Relationship methodsFor: 'accessing' stamp: 'mu 12/24/2011 23:33'!
startNode
	^ self db nodeAt: self startNodeId! !

!N4Relationship methodsFor: 'accessing' stamp: 'mu 12/14/2011 00:01'!
startNodeId
	"Answer the value of startNodeId"

	^ startNodeId! !

!N4Relationship methodsFor: 'accessing' stamp: 'mu 12/14/2011 00:01'!
startNodeId: anObject
	"Set the value of startNodeId"

	startNodeId := anObject! !

!N4Relationship methodsFor: 'accessing' stamp: 'mu 12/11/2011 00:14'!
type
	"Answer the value of type"

	^ type! !

!N4Relationship methodsFor: 'accessing' stamp: 'mu 12/11/2011 00:14'!
type: anObject
	"Set the value of type"

	type := anObject! !

!N4Relationship methodsFor: 'accessing' stamp: 'mu 12/21/2011 01:01'!
uri
	^ self restClient rootUri, 'relationship/', self id! !

Object subclass: #N4Indexer
	instanceVariableNames: 'db'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-IndexModel'!

!N4Indexer class methodsFor: 'instance creation' stamp: 'mu 12/21/2011 00:44'!
on: graphDb
	^ self new db: graphDb; yourself! !

!N4Indexer methodsFor: 'accessing' stamp: 'mu 12/21/2011 00:43'!
db
	"Answer the value of db"

	^ db! !

!N4Indexer methodsFor: 'accessing' stamp: 'mu 12/21/2011 00:43'!
db: anObject
	"Set the value of db"

	db := anObject! !

!N4Indexer methodsFor: 'actions' stamp: 'mu 12/21/2011 00:52'!
nodeIndexesNamed: indexName
	^ N4NodeIndexes on: self named: indexName! !

!N4Indexer methodsFor: 'actions' stamp: 'mu 12/21/2011 00:53'!
relationshipIndexesNamed: indexName
	^ N4RelationshipIndexes on: self named: indexName! !

!N4Indexer methodsFor: 'accessing' stamp: 'mu 12/21/2011 00:55'!
restClient
	^self db restClient! !

Object subclass: #N4Indexes
	instanceVariableNames: 'name indexer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-IndexModel'!

!N4Indexes class methodsFor: 'instance creation' stamp: 'mu 12/21/2011 00:52'!
on: indexer
	^ self new indexer: indexer; yourself! !

!N4Indexes class methodsFor: 'instance creation' stamp: 'mu 12/21/2011 00:53'!
on: indexer named: indexName
	^ self new indexer: indexer; name: indexName; yourself! !

!N4Indexes methodsFor: 'actions' stamp: 'mu 12/21/2011 01:01'!
addKey: key value: value for: graphEntry
	! !

!N4Indexes methodsFor: 'actions' stamp: 'mu 2/19/2012 16:28'!
delete! !

!N4Indexes methodsFor: 'actions' stamp: 'mu 2/16/2012 23:58'!
detectWith: keyValueAssoc
	^self detectWithKey: keyValueAssoc key value: keyValueAssoc value! !

!N4Indexes methodsFor: 'actions' stamp: 'mu 12/24/2011 22:57'!
detectWithKey: key value: value! !

!N4Indexes methodsFor: 'accessing' stamp: 'mu 12/21/2011 00:52'!
indexer
	"Answer the value of indexer"

	^ indexer! !

!N4Indexes methodsFor: 'accessing' stamp: 'mu 12/21/2011 00:52'!
indexer: anObject
	"Set the value of indexer"

	indexer := anObject! !

!N4Indexes methodsFor: 'accessing' stamp: 'mu 12/21/2011 00:52'!
name
	^name! !

!N4Indexes methodsFor: 'accessing' stamp: 'mu 12/21/2011 00:47'!
name: anObject
	"Set the value of name"

	name := anObject! !

!N4Indexes methodsFor: 'actions' stamp: 'mu 2/19/2012 16:24'!
removeAllFor: graphObject! !

!N4Indexes methodsFor: 'actions' stamp: 'mu 2/19/2012 16:26'!
removeAllKeyed: key for: graphEntry
	^self restClient removeNodeIndexes: self name from: key key: graphEntry id! !

!N4Indexes methodsFor: 'actions' stamp: 'mu 2/19/2012 16:27'!
removeAllKeyed: key value: value for: graphEntry
	! !

!N4Indexes methodsFor: 'accessing' stamp: 'mu 12/21/2011 00:55'!
restClient
	^self indexer restClient! !

N4Indexes subclass: #N4NodeIndexes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-IndexModel'!

!N4NodeIndexes methodsFor: 'actions' stamp: 'mu 2/19/2012 16:38'!
addKey: key value: value for: graphEntry
	^self restClient addNodeIndex: self name on: graphEntry uri key: key value: value! !

!N4NodeIndexes methodsFor: 'actions' stamp: 'mu 2/19/2012 21:07'!
delete
	^ self restClient deleteNodeIndexes: self name! !

!N4NodeIndexes methodsFor: 'actions' stamp: 'mu 12/24/2011 23:04'!
detectWithKey: key value: value
	| jsons |
	jsons := self restClient getNodeWithIndex: self name key: key value: value.
	^N4Node json: jsons first! !

!N4NodeIndexes methodsFor: 'actions' stamp: 'mu 2/19/2012 16:31'!
removeAllFor: graphObject
	^self restClient removeNodeIndexes: self name on: graphObject id! !

!N4NodeIndexes methodsFor: 'actions' stamp: 'mu 2/19/2012 16:26'!
removeAllKeyed: key for: graphEntry
	^self restClient removeNodeIndexes: self name from: key key: graphEntry id! !

!N4NodeIndexes methodsFor: 'actions' stamp: 'mu 2/19/2012 16:28'!
removeAllKeyed: key value: value for: graphEntry
	^self restClient removeNodeIndexes: self name from: graphEntry id key: key value: value! !

N4Indexes subclass: #N4RelationshipIndexes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-IndexModel'!

!N4RelationshipIndexes methodsFor: 'actions' stamp: 'mu 2/19/2012 16:38'!
addKey: key value: value for: graphEntry
	^self restClient addRelationshipIndex: self name on: graphEntry uri key: key value: value! !

!N4RelationshipIndexes methodsFor: 'actions' stamp: 'mu 2/19/2012 21:08'!
delete
	^ self restClient deleteRelationshipIndexes: self name! !

!N4RelationshipIndexes methodsFor: 'actions' stamp: 'mu 2/17/2012 00:15'!
detectWithKey: key value: value
	| jsons |
	jsons := self restClient getRelationshipWithIndex: self name key: key value: value.
	^N4Relationship json: jsons first! !

!N4RelationshipIndexes methodsFor: 'actions' stamp: 'mu 2/19/2012 16:32'!
removeAllFor: graphEntry
	^self restClient removeRelationshipIndexes: self name on: graphEntry id! !

!N4RelationshipIndexes methodsFor: 'actions' stamp: 'mu 2/19/2012 16:26'!
removeAllKeyed: key for: graphEntry
	^self restClient removeRelationshipIndexes: self name from: key key: graphEntry id! !

!N4RelationshipIndexes methodsFor: 'actions' stamp: 'mu 2/19/2012 16:28'!
removeAllKeyed: key value: value for: graphEntry
	^self restClient removeRelationshipIndexes: self name from: graphEntry id key: key value: value! !

Object subclass: #N4ObjectDumper
	instanceVariableNames: 'db count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Demo-Dumper'!

!N4ObjectDumper class methodsFor: 'actions' stamp: 'mu 12/23/2011 22:38'!
dump: anObject
	| inst |
	inst := self on: N4GraphDb new.
	inst dump: anObject.	
	^inst! !

!N4ObjectDumper class methodsFor: 'examples' stamp: 'mu 2/16/2012 23:38'!
example1
	"N4ObjectDumper example1"
	| snapshot workingCopy |
	workingCopy := MCWorkingCopy allManagers detect: [:each | each package name = 'Neo4reSt'].
	snapshot := workingCopy package snapshot.
	N4ObjectDumper dump: snapshot.! !

!N4ObjectDumper class methodsFor: 'instance creation' stamp: 'mu 12/23/2011 22:19'!
on: aGraphDb
	^ self new db: aGraphDb; yourself! !

!N4ObjectDumper methodsFor: 'private' stamp: 'mu 12/23/2011 22:17'!
checkTooManyRecursion
	self count: (self count + 1).
	self count >= 1000000 ifTrue: [self halt]! !

!N4ObjectDumper methodsFor: 'accessing' stamp: 'mu 12/23/2011 22:16'!
count
	"Answer the value of count"

	^ count ifNil: [count := 0]! !

!N4ObjectDumper methodsFor: 'accessing' stamp: 'mu 12/23/2011 22:16'!
count: anObject
	"Set the value of count"

	count := anObject! !

!N4ObjectDumper methodsFor: 'accessing' stamp: 'mu 12/23/2011 21:52'!
db
	"Answer the value of db"

	^ db! !

!N4ObjectDumper methodsFor: 'accessing' stamp: 'mu 12/23/2011 21:52'!
db: anObject
	"Set the value of db"

	db := anObject! !

!N4ObjectDumper methodsFor: 'dumping' stamp: 'mu 12/23/2011 22:58'!
dump: startObject 
	| newNode |
	newNode := self db createNode.
	self labelStartNode: newNode.
	self dumpObject: startObject to: newNode
	
! !

!N4ObjectDumper methodsFor: 'private-dumping' stamp: 'mu 12/23/2011 22:44'!
dumpClassInfo: anObject to: aNode
	aNode at: '_className' put: anObject class name asString. 
	aNode at: '_superclassName' put: anObject class superclass name. ! !

!N4ObjectDumper methodsFor: 'private-dumping' stamp: 'mu 12/23/2011 23:22'!
dumpNextObject: nextObj named: eachName to: aNode 
	| newNode |
	newNode := self db createNode.
	aNode relateTo: newNode type: eachName.
	self dumpObject: nextObj to: newNode! !

!N4ObjectDumper methodsFor: 'private-dumping' stamp: 'mu 12/23/2011 23:23'!
dumpObject: anObject to: aNode 
	self checkTooManyRecursion.
	self dumpClassInfo: anObject to: aNode.
	anObject class allInstVarNames
		do: [:eachName | 
			| childObj |
			childObj := anObject instVarNamed: eachName.
			(self shouldDumpAsProperty: childObj)
				ifTrue: [self dumpProperty: childObj named: eachName to: aNode]
				ifFalse: [self dumpNextObject: childObj named: eachName to: aNode]].
	anObject class isVariable
		ifTrue: [anObject
				keysAndValuesDo: [:key :value | 
					self dumpNextObject: value named: key to: aNode]]! !

!N4ObjectDumper methodsFor: 'private-dumping' stamp: 'mu 2/5/2012 16:30'!
dumpProperty: propValue named: propName to: aNode
	[ aNode at: propName put: propValue ] on: Error do: [:ex |
		[ aNode at: propName put: propValue toStomp "last resort - write as StOMP bytes"	] on: MessageNotUnderstood do: [:e |
			self error: 'This demo requires StOMP'
		]
	]! !

!N4ObjectDumper methodsFor: 'private' stamp: 'mu 12/23/2011 22:57'!
labelStartNode: startNode
	| timestampKey |
	timestampKey := DateAndTime now printString.
	db initialNode relateTo: startNode type: timestampKey! !

!N4ObjectDumper methodsFor: 'testing' stamp: 'mu 12/23/2011 23:26'!
shouldDumpAsProperty: anObject
	anObject isString ifTrue: [^true].
	anObject isNumber ifTrue: [^true].
	anObject isNil ifTrue: [^true].
	anObject == true ifTrue: [^true].
	anObject == false ifTrue: [^true].
	
	^false
	! !

Object subclass: #N4PortableUtil
	instanceVariableNames: ''
	classVariableNames: 'ActualClass'
	poolDictionaries: ''
	category: 'Neo4reSt-Core'!

N4PortableUtil class
	instanceVariableNames: 'default'!

N4PortableUtil class
	instanceVariableNames: 'default'!

!N4PortableUtil class methodsFor: 'private' stamp: 'mu 11/27/2011 12:39'!
activate
	ActualClass := self.
	^ActualClass! !

!N4PortableUtil class methodsFor: 'instance creation' stamp: 'mu 11/27/2011 16:18'!
default
	default ifNil: [default := ((N4PortableUtil subclasses at: 1) activate) new].
	^ default! !

!N4PortableUtil class methodsFor: 'class initialization' stamp: 'mu 11/27/2011 12:39'!
initDefault
	default := nil! !

!N4PortableUtil class methodsFor: 'class initialization' stamp: 'mu 11/27/2011 12:39'!
initialize
	"override"! !

!N4PortableUtil methodsFor: 'converting' stamp: 'mu 2/13/2012 00:51'!
asProperties: someProps

	^someProps isArray ifTrue: [someProps] ifFalse: [Array with: someProps].! !

!N4PortableUtil methodsFor: 'actions' stamp: 'mu 11/27/2011 22:41'!
deleteJsonFrom: urlString ! !

!N4PortableUtil methodsFor: 'actions' stamp: 'mu 11/27/2011 22:42'!
getJsonFrom: urlString

	! !

!N4PortableUtil methodsFor: 'actions' stamp: 'mu 11/29/2011 23:03'!
getJsonOrEmptyFrom: urlString

	^[self getJsonFrom: urlString]
		on: N4NoContent
		do: [:ex | ex return: #()]! !

!N4PortableUtil methodsFor: 'actions-http' stamp: 'mu 11/27/2011 22:41'!
httpJsonDelete: urlString ! !

!N4PortableUtil methodsFor: 'actions-http' stamp: 'mu 11/29/2011 22:59'!
httpJsonGet: urlString
! !

!N4PortableUtil methodsFor: 'actions-http' stamp: 'mu 11/27/2011 22:41'!
httpJsonPost: urlString
	
	! !

!N4PortableUtil methodsFor: 'actions-http' stamp: 'mu 11/27/2011 22:41'!
httpJsonPost: urlString content: jsonString
	
	! !

!N4PortableUtil methodsFor: 'read/write' stamp: 'mu 11/27/2011 22:42'!
jsonStringFrom: assocs
	! !

!N4PortableUtil methodsFor: 'read/write' stamp: 'mu 12/9/2011 00:35'!
pickIdFrom: uriString 
	"N4SqPortableUtil default pickIdFrom: 'http://localhost:7474/db/data/node/10'"
	"N4SqPortableUtil default pickIdFrom: 'http://localhost:7474/db/'"
	| sz |
	(sz := uriString size)
		to: 1
		by: -1
		do: [:idx | $/ = (uriString at: idx)
				ifTrue: [| chopped |
					chopped := uriString copyFrom: idx + 1 to: sz.
					^ chopped isEmpty
						ifTrue: [0]
						ifFalse: [chopped asInteger]]].
	^ -1! !

!N4PortableUtil methodsFor: 'actions' stamp: 'mu 11/27/2011 22:40'!
postJson: json to: urlString

	! !

!N4PortableUtil methodsFor: 'actions' stamp: 'mu 11/27/2011 22:41'!
postJsonTo: urlString
	! !

!N4PortableUtil methodsFor: 'read/write' stamp: 'mu 11/27/2011 22:42'!
readJsonFrom: aStream

	! !

!N4PortableUtil methodsFor: 'read/write' stamp: 'mu 12/23/2011 13:05'!
readJsonFromResponse: httpResponse! !

!N4PortableUtil methodsFor: 'error handling' stamp: 'mu 11/27/2011 22:42'!
signalErrorBasedOn: response ! !

!N4PortableUtil methodsFor: 'misc utils' stamp: 'mu 11/27/2011 23:58'!
string: aString beginsWith: prefix 
	^ (prefix, '*') match: aString! !

N4PortableUtil subclass: #N4SqPortableUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Squeak-Core'!

!N4SqPortableUtil class methodsFor: 'class initialization' stamp: 'mu 11/27/2011 16:17'!
initialize
	self activate! !

!N4SqPortableUtil methodsFor: 'actions' stamp: 'mu 12/23/2011 13:05'!
getJsonFrom: urlString 
	| response |
	response := self httpJsonGet: urlString.
	^self readJsonFromResponse: response! !

!N4SqPortableUtil methodsFor: 'accessing' stamp: 'mu 11/27/2011 16:37'!
httpClient
	
	^ WebClient new! !

!N4SqPortableUtil methodsFor: 'actions-http' stamp: 'mu 12/4/2011 15:59'!
httpJsonDelete: urlString 
	| resp |
	resp := self httpClient jsonDelete: urlString.
	resp code = 409 ifTrue: [^N4CannotDelete response: resp].
	^ resp! !

!N4SqPortableUtil methodsFor: 'actions-http' stamp: 'mu 11/29/2011 23:00'!
httpJsonGet: urlString
	| resp |
	resp := self httpClient jsonGet: urlString.
	self signalErrorBasedOn: resp.
	^ resp! !

!N4SqPortableUtil methodsFor: 'actions-http' stamp: 'mu 11/27/2011 16:36'!
httpJsonPost: urlString
	
	^ self httpClient jsonPost: urlString! !

!N4SqPortableUtil methodsFor: 'actions-http' stamp: 'mu 11/27/2011 16:52'!
httpJsonPost: urlString content: jsonString
	
	^ self httpClient jsonPost: urlString content: jsonString! !

!N4SqPortableUtil methodsFor: 'actions-http' stamp: 'mu 12/2/2011 00:03'!
httpJsonPut: urlString content: jsonString
	
	^ self httpClient jsonPut: urlString content: jsonString! !

!N4SqPortableUtil methodsFor: 'read/write' stamp: 'mu 12/23/2011 23:08'!
jsonStringFrom: valueOrAssocs 
	| dict rawJsonString param |
	(valueOrAssocs isArray or: [valueOrAssocs class = OrderedCollection])
		ifTrue: [dict := Dictionary new: valueOrAssocs size.
			dict addAll: valueOrAssocs.
			param := dict]
		ifFalse: [param := valueOrAssocs].
	rawJsonString := Json render: param.
	^ self utf8StringFrom: rawJsonString! !

!N4SqPortableUtil methodsFor: 'actions' stamp: 'mu 11/27/2011 16:39'!
postJson: json to: urlString

	! !

!N4SqPortableUtil methodsFor: 'actions' stamp: 'mu 11/27/2011 16:41'!
postJsonTo: urlString
	^self readJsonFrom: (self httpJsonPost: urlString) contentStream! !

!N4SqPortableUtil methodsFor: 'read/write' stamp: 'mu 11/27/2011 16:39'!
readJsonFrom: aStream

	^ Json readFrom: aStream! !

!N4SqPortableUtil methodsFor: 'actions' stamp: 'mu 12/24/2011 23:50'!
readJsonFromResponse: httpResponse
	| strm |
	"strm := (httpResponse headerAt: 'transfer-encoding') = 'chunked' ifTrue: [httpResponse content readStream] ifFalse: [httpResponse contentStream]."
	strm := httpResponse content readStream.
	^ self readJsonFrom: strm! !

!N4SqPortableUtil methodsFor: 'error handling' stamp: 'mu 11/29/2011 22:59'!
signalErrorBasedOn: response
	| code |
	code := response code.
	(code between: 200 and: 203) ifTrue: [^self].
	code = 204 ifTrue: [^ (N4NoContent response: response) signal].
	code = 404
		ifTrue: [^ (N4NotFound response: response) signal].
	^ (N4Error response: response) signal! !

!N4SqPortableUtil methodsFor: 'misc utils' stamp: 'mu 11/27/2011 23:58'!
string: aString beginsWith: prefix 
	^ aString beginsWith: prefix ! !

!N4SqPortableUtil methodsFor: 'read/write' stamp: 'mu 11/27/2011 17:15'!
utf8StringFrom: squeakString
	^ squeakString squeakToUtf8 ! !

Object subclass: #N4RestClient
	instanceVariableNames: 'rawClient'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Client'!

!N4RestClient class methodsFor: 'instance creation' stamp: 'mu 11/27/2011 22:38'!
rootUri: rootUri
	^ self new rootUri: rootUri; yourself! !

!N4RestClient methodsFor: 'actions-indexers' stamp: 'mu 2/19/2012 21:10'!
addNodeIndex: indexName on: nodeUri key: key value: value
	^self rawClient addNodeIndex: indexName on: nodeUri key: key value: value! !

!N4RestClient methodsFor: 'actions-indexers' stamp: 'mu 2/19/2012 16:39'!
addRelationshipIndex: indexName on: nodeUri key: key value: value
	^self rawClient addRelationshipIndex: indexName on: nodeUri key: key value: value! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/2/2011 00:11'!
createNode
	^ self rawClient createNode! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 2/13/2012 00:56'!
createNode: properties
	| props |
	props := N4PortableUtil default asProperties: properties.
	^self rawClient createNode: props! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:19'!
createRelationshipAt: nodeId to: uri type: type
	^self rawClient createRelationshipAt: nodeId to: uri type: type! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 2/13/2012 01:00'!
createRelationshipAt: nodeId to: uri type: type properties: properties
	| props |
	props := N4PortableUtil default asProperties: properties.
	^self rawClient createRelationshipAt: nodeId to: uri type: type properties: props! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:19'!
deleteNodeAt: id 
	| response |
	response := self rawClient deleteNodeAt: id.
	^ response code = 204! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/19/2011 23:26'!
deleteNodeIndex: indexName
	^ self rawClient deleteNodeIndex: indexName! !

!N4RestClient methodsFor: 'actions-indexers' stamp: 'mu 2/19/2012 21:06'!
deleteNodeIndexes: indexName
	^ self rawClient deleteNodeIndexes: indexName! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:50'!
deletePropertiesNodeAt: nodeId 
	| response |
	response := self rawClient deletePropertiesNodeAt: nodeId.
	^ response code = 204! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 16:46'!
deletePropertiesRelationshipAt: relId 
	| response |
	response := self rawClient deletePropertiesRelationshipAt: relId.
	^ response code = 204! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/6/2011 23:53'!
deleteProperty: propName nodeAt: nodeId 
	| response |
	response := self rawClient deleteProperty: propName nodeAt: nodeId.
	^ response code = 204! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/6/2011 23:51'!
deleteProperty: propName relationshipAt: relId 
	| response |
	response := self rawClient deleteProperty: propName relationshipAt: relId.
	^ response code = 204! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/6/2011 23:56'!
deleteRelationshipAt: id 
	| response |
	response := self rawClient deleteRelationshipAt: id.
	^ response code = 204! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/19/2011 23:26'!
deleteRelationshipIndex: indexName
	^ self rawClient deleteRelationshipIndex: indexName! !

!N4RestClient methodsFor: 'actions-indexers' stamp: 'mu 2/19/2012 21:06'!
deleteRelationshipIndexes: indexName
	^ self rawClient deleteRelationshipIndexes: indexName! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:20'!
getAllRelationshipsAt: nodeId
	^self rawClient getAllRelationshipsAt: nodeId
	! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/23/2011 13:31'!
getAllRelationshipsAt: nodeId type: type
	^self getAllRelationshipsAt: nodeId types: (Array with: type)! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:20'!
getAllRelationshipsAt: nodeId types: typeCollection
	^self rawClient getAllRelationshipsAt: nodeId types: typeCollection! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:22'!
getInRelationshipsAt: nodeId
	^self rawClient getInRelationshipsAt: nodeId! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/23/2011 13:31'!
getInRelationshipsAt: nodeId type: type
	^self getInRelationshipsAt: nodeId types: (Array with: type)! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:22'!
getInRelationshipsAt: nodeId types: typeCollection
	^self rawClient getInRelationshipsAt: nodeId types: typeCollection! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/13/2011 23:35'!
getNodeAt: id 
	| resp |
	resp := self rawClient getNodeAt: id.
	^resp! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/19/2011 23:20'!
getNodeIndexes
	^ self rawClient getNodeIndexes! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/19/2011 23:58'!
getNodeWithIndex: indexName key: key value: value
	^self rawClient getNodeWithIndex: indexName key: key value: value! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:22'!
getOutRelationshipsAt: nodeId
	^self rawClient getOutRelationshipsAt: nodeId! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/23/2011 13:30'!
getOutRelationshipsAt: nodeId type: type
	^self getOutRelationshipsAt: nodeId types: (Array with: type)! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:22'!
getOutRelationshipsAt: nodeId types: typeCollection
	^self rawClient getOutRelationshipsAt: nodeId types: typeCollection! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:44'!
getPropertiesNodeAt: nodeId 
	^ self rawClient getPropertiesNodeAt: nodeId ! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:22'!
getPropertiesRelationshipAt: relId 
	^ self rawClient getPropertiesRelationshipAt: relId ! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:36'!
getProperty: propName nodeAt: nodeId
	^ self rawClient getProperty: propName nodeAt: nodeId! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:17'!
getProperty: propName relationshipAt: relId
	^ self rawClient getProperty: propName relationshipAt: relId! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/13/2011 23:35'!
getRelationshipAt: id 
	| resp |
	resp := self rawClient getRelationshipAt: id.
	^ resp! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/19/2011 23:20'!
getRelationshipIndexes
	^ self rawClient getRelationshipIndexes! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/7/2011 00:00'!
getRelationshipTypes
	^ self rawClient getRelationshipTypes! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/19/2011 23:59'!
getRelationshipWithIndex: indexName key: key value: value
	^self rawClient getRelationshipWithIndex: indexName key: key value: value! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:21'!
getRelationshipsAt: nodeId direction: direction types: typeCollection
	^ self rawClient getRelationshipsAt: nodeId direction: direction types: typeCollection! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:21'!
getRoot
	^self rawClient getRoot! !

!N4RestClient methodsFor: 'accessing' stamp: 'mu 12/4/2011 15:23'!
portableUtil
	^self rawClient portableUtil! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/24/2011 15:55'!
queryByCypher: queryString
	| resp |
	resp := self rawClient queryByCypher: queryString.
	^self portableUtil readJsonFromResponse: resp! !

!N4RestClient methodsFor: 'accessing' stamp: 'mu 12/2/2011 00:10'!
rawClient

	^ rawClient ifNil: [rawClient := N4RestRawClient new]! !

!N4RestClient methodsFor: 'accessing' stamp: 'mu 12/2/2011 00:09'!
rawClient: anObject
	"Set the value of rawClient"

	rawClient := anObject! !

!N4RestClient methodsFor: 'actions-indexers' stamp: 'mu 2/19/2012 21:03'!
removeNodeIndexes: indexName on: nodeId
	^ self rawClient removeNodeIndexes: indexName on: nodeId! !

!N4RestClient methodsFor: 'actions-indexers' stamp: 'mu 2/19/2012 21:03'!
removeNodeIndexes: indexName on: nodeId key: key
	^ self rawClient removeNodeIndexes: indexName on: nodeId key: key! !

!N4RestClient methodsFor: 'actions-indexers' stamp: 'mu 2/19/2012 21:03'!
removeNodeIndexes: indexName on: nodeId key: key value: value
	^ self rawClient removeNodeIndexes: indexName on: nodeId key: key value: value! !

!N4RestClient methodsFor: 'actions-indexers' stamp: 'mu 2/19/2012 21:03'!
removeRelationshipIndexes: indexName on: nodeId
	^ self rawClient removeRelationshipIndexes: indexName on: nodeId! !

!N4RestClient methodsFor: 'actions-indexers' stamp: 'mu 2/19/2012 21:03'!
removeRelationshipIndexes: indexName on: nodeId key: key
	^ self rawClient removeRelationshipIndexes: indexName on: nodeId key: key! !

!N4RestClient methodsFor: 'actions-indexers' stamp: 'mu 2/19/2012 21:03'!
removeRelationshipIndexes: indexName on: nodeId key: key value: value
	^ self rawClient removeRelationshipIndexes: indexName on: nodeId key: key value: value! !

!N4RestClient methodsFor: 'accessing' stamp: 'mu 12/2/2011 00:11'!
rootUri
	^ self rawClient rootUri! !

!N4RestClient methodsFor: 'accessing' stamp: 'mu 12/2/2011 00:11'!
rootUri: uriString
	self rawClient rootUri: uriString! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 2/13/2012 00:54'!
setProperties: properties nodeAt: nodeId
	| props resp |
	props := N4PortableUtil default asProperties: properties.
	resp := self rawClient setProperties: props nodeAt: nodeId.
	^ resp code ~= 404! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 2/13/2012 00:54'!
setProperties: properties relationshipAt: relId
	| props resp |
	props := N4PortableUtil default asProperties: properties.
	resp := self rawClient setProperties: props relationshipAt: relId.
	^ resp code ~= 404! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:32'!
setProperty: propName to: value nodeAt: nodeId 
	| resp |
	resp := self rawClient setProperty: propName to: value nodeAt: nodeId.
	^ resp code ~= 404! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:14'!
setProperty: propName to: value relationshipAt: relId 
	| resp |
	resp := self rawClient setProperty: propName to: value relationshipAt: relId.
	^ resp code ~= 404! !

!N4RestClient methodsFor: 'actions' stamp: 'mu 12/23/2011 13:06'!
traverseFrom: nodeId using: traversalDescription
	| resp |
	resp := self rawClient traverseFrom: nodeId using: traversalDescription.
	^self portableUtil readJsonFromResponse: resp
! !

Object subclass: #N4RestRawClient
	instanceVariableNames: 'rootUri'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Client'!

!N4RestRawClient class methodsFor: 'instance creation' stamp: 'mu 12/2/2011 00:08'!
rootUri: rootUri
	^ self new rootUri: rootUri; yourself! !

!N4RestRawClient methodsFor: 'actions-indexes' stamp: 'mu 2/19/2012 16:38'!
addNodeIndex: indexName on: nodeUri key: key value: value
	|json jsonString |
	json := self newNodeIndexJson: nodeUri key: key value: value.
	jsonString := self portableUtil jsonStringFrom: json.
	^ self portableUtil httpJsonPost: (self rootUri, 'index/node/', indexName asString) content: jsonString! !

!N4RestRawClient methodsFor: 'actions-indexes' stamp: 'mu 2/19/2012 16:38'!
addRelationshipIndex: indexName on: relationshipUri key: key value: value
	|json jsonString |
	json := self newRelationshipIndexJson: relationshipUri key: key value: value.
	jsonString := self portableUtil jsonStringFrom: json.
	^ self portableUtil httpJsonPost: (self rootUri, 'index/relationship/', indexName asString) content: jsonString! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/2/2011 00:08'!
createNode
	^ self portableUtil httpJsonPost: self rootUri, 'node'! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/9/2011 00:04'!
createNode: properties
	| jsonString |
	jsonString := self portableUtil jsonStringFrom: properties.
	^ self portableUtil httpJsonPost: self rootUri, 'node' content: jsonString! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/2/2011 00:08'!
createRelationshipAt: nodeId to: uri type: type
	^self createRelationshipAt: nodeId to: uri type: type properties: nil! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/23/2011 23:31'!
createRelationshipAt: nodeId to: uri type: type properties: assocs
	|json jsonString |
	json := self newRelationshipJson: uri type: type asString properties: assocs.
	jsonString := self portableUtil jsonStringFrom: json.
	^ self portableUtil httpJsonPost: (self rootUri, 'node/', nodeId asString, '/relationships') content: jsonString! !

!N4RestRawClient methodsFor: 'defaults' stamp: 'mu 12/2/2011 00:08'!
defaultRootUri
	^'http://localhost:7474/db/data/'! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/2/2011 00:15'!
deleteNodeAt: id 
	^ self portableUtil httpJsonDelete: self rootUri , 'node/', id asString! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/19/2011 23:25'!
deleteNodeIndex: indexName
	^ self portableUtil httpJsonDelete: self rootUri , 'index/node/' , indexName! !

!N4RestRawClient methodsFor: 'actions-indexes' stamp: 'mu 2/19/2012 21:04'!
deleteNodeIndexes: indexName
	^ self portableUtil httpJsonDelete: (self rootUri, 'index/node/', indexName asString) ! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:50'!
deletePropertiesNodeAt: nodeId 
	^ self portableUtil httpJsonDelete: self rootUri , 'node/' , nodeId asString , '/properties'! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/4/2011 16:45'!
deletePropertiesRelationshipAt: relId 
	^ self portableUtil httpJsonDelete: self rootUri , 'relationship/' , relId asString , '/properties'! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/6/2011 23:52'!
deleteProperty: propName nodeAt: nodeId 
	^ self portableUtil httpJsonDelete: self rootUri , 'node/' , nodeId asString , '/properties/', propName! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/6/2011 23:51'!
deleteProperty: propName relationshipAt: relId 
	^ self portableUtil httpJsonDelete: self rootUri , 'relationship/' , relId asString , '/properties/', propName! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/6/2011 23:56'!
deleteRelationshipAt: relId 
	^ self portableUtil httpJsonDelete: self rootUri , 'relationship/', relId asString! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/19/2011 23:25'!
deleteRelationshipIndex: indexName
	^ self portableUtil httpJsonDelete: self rootUri , 'index/relationship/' , indexName! !

!N4RestRawClient methodsFor: 'actions-indexes' stamp: 'mu 2/19/2012 21:05'!
deleteRelationshipIndexes: indexName
	^ self portableUtil httpJsonDelete: (self rootUri, 'index/relationship/', indexName asString) ! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/2/2011 00:08'!
getAllRelationshipsAt: nodeId
	^self getAllRelationshipsAt: nodeId types: nil! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/2/2011 00:08'!
getAllRelationshipsAt: nodeId types: typeCollection
	^self getRelationshipsAt: nodeId direction: #all types: typeCollection! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/2/2011 00:08'!
getInRelationshipsAt: nodeId
	^self getInRelationshipsAt: nodeId types: nil! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/2/2011 00:08'!
getInRelationshipsAt: nodeId types: typeCollection
	^self getRelationshipsAt: nodeId direction: #in types: typeCollection! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/13/2011 23:26'!
getNodeAt: id 
	^ self portableUtil httpJsonGet: self rootUri , 'node/', id asString
		! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/19/2011 23:21'!
getNodeIndexes
	^ self portableUtil getJsonFrom: self rootUri , 'index/node'! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/19/2011 23:58'!
getNodeWithIndex: indexName key: key value: value
	^ self portableUtil getJsonFrom: self rootUri , 'index/node/' , indexName asString , '/', key, '/', value! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/2/2011 00:08'!
getOutRelationshipsAt: nodeId
	^self getOutRelationshipsAt: nodeId types: nil! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/2/2011 00:08'!
getOutRelationshipsAt: nodeId types: typeCollection
	^self getRelationshipsAt: nodeId direction: #out types: typeCollection! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:44'!
getPropertiesNodeAt: nodeId 
	^ self portableUtil getJsonOrEmptyFrom: self rootUri , 'node/' , nodeId asString , '/properties'! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:12'!
getPropertiesRelationshipAt: relId 
	^ self portableUtil getJsonOrEmptyFrom: self rootUri , 'relationship/' , relId asString , '/properties'! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:35'!
getProperty: propName nodeAt: nodeId
	^ self portableUtil getJsonFrom: self rootUri , 'node/' , nodeId asString , '/properties/', propName ! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:12'!
getProperty: propName relationshipAt: relId
	^ self portableUtil getJsonFrom: self rootUri , 'relationship/' , relId asString , '/properties/', propName ! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/13/2011 23:32'!
getRelationshipAt: id 
	^ self portableUtil httpJsonGet: self rootUri , 'relationship/', id asString
		! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/19/2011 23:22'!
getRelationshipIndexes
	^ self portableUtil getJsonFrom: self rootUri , 'index/relationship'! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/7/2011 00:01'!
getRelationshipTypes
	^ self portableUtil getJsonFrom: self rootUri , 'relationship/types'! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/19/2011 23:58'!
getRelationshipWithIndex: indexName key: key value: value
	^ self portableUtil getJsonFrom: self rootUri , 'index/relationship/' , indexName asString , '/', key, '/', value! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/13/2011 23:50'!
getRelationshipsAt: nodeId direction: direction types: typeCollection
	| uriStream |
	uriStream := WriteStream with: (self rootUri , 'node/', nodeId asString).
	uriStream nextPutAll: '/relationships/' ; nextPutAll: direction asString.
	(typeCollection isNil or: [typeCollection isEmpty]) ifFalse: [uriStream nextPut: $/.
		typeCollection do: [:each | uriStream nextPutAll: each] separatedBy: [uriStream nextPut: $&]
	].

	^ self portableUtil getJsonFrom: uriStream contents! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/2/2011 00:08'!
getRoot
	^ self portableUtil getJsonFrom: self rootUri! !

!N4RestRawClient methodsFor: 'builder' stamp: 'mu 12/19/2011 23:38'!
newNodeIndexJson: uriOrNodeId key: key value: value
	| uri jsonAssocs |
	jsonAssocs := OrderedCollection new: 3.
	uri := uriOrNodeId asString.
	(self portableUtil string: uri beginsWith: 'http:') ifFalse: [uri := (self rootUri, 'node/', uri)].
	jsonAssocs add: ('uri' -> uri).
	jsonAssocs add: ('key' -> key).
	jsonAssocs add: ('value' -> value).
	^jsonAssocs! !

!N4RestRawClient methodsFor: 'builder' stamp: 'mu 12/24/2011 15:41'!
newQueryJson: queryString params: array
	| jsonAssocs |
	jsonAssocs := OrderedCollection new.
	jsonAssocs add: ('query' -> queryString).
	jsonAssocs add: ('params' -> array).
	^jsonAssocs! !

!N4RestRawClient methodsFor: 'builder' stamp: 'mu 12/19/2011 23:40'!
newRelationshipIndexJson: uriOrNodeId key: key value: value
	| uri jsonAssocs |
	jsonAssocs := OrderedCollection new: 3.
	uri := uriOrNodeId asString.
	(self portableUtil string: uri beginsWith: 'http:') ifFalse: [uri := (self rootUri, 'relationship/', uri)].
	jsonAssocs add: ('uri' -> uri).
	jsonAssocs add: ('key' -> key).
	jsonAssocs add: ('value' -> value).
	^jsonAssocs! !

!N4RestRawClient methodsFor: 'builder' stamp: 'mu 12/2/2011 00:08'!
newRelationshipJson: uriOrNodeId type: type properties: assocs
	| uri jsonAssocs |
	jsonAssocs := OrderedCollection new: 3.
	uri := uriOrNodeId asString.
	(self portableUtil string: uri beginsWith: 'http:') ifFalse: [uri := (self rootUri, 'node/', uri)].
	jsonAssocs add: ('to' -> uri).
	jsonAssocs add: ('type' -> type).
	(assocs isNil or: [assocs isEmpty]) ifFalse: [
		jsonAssocs add: ('data' -> (Dictionary new addAll: assocs; yourself))
	].
	^jsonAssocs! !

!N4RestRawClient methodsFor: 'accessing' stamp: 'mu 12/2/2011 00:08'!
portableUtil
	^N4PortableUtil default! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/24/2011 15:55'!
queryByCypher: queryString
	| json jsonString |
	json := self newQueryJson: queryString params: Dictionary new.
	jsonString := self portableUtil jsonStringFrom: json.
	^ self portableUtil httpJsonPost: (self rootUri, 'cypher') content: jsonString! !

!N4RestRawClient methodsFor: 'actions-indexes' stamp: 'mu 2/19/2012 16:31'!
removeNodeIndexes: indexName on: nodeId
	^ self portableUtil httpJsonDelete: (self rootUri, 'index/node/', indexName asString, '/', nodeId asString) ! !

!N4RestRawClient methodsFor: 'actions-indexes' stamp: 'mu 2/19/2012 21:01'!
removeNodeIndexes: indexName on: nodeId key: key
	^ self portableUtil httpJsonDelete: (self rootUri, 'index/node/', indexName asString, '/', key asString, '/', nodeId asString) ! !

!N4RestRawClient methodsFor: 'actions-indexes' stamp: 'mu 2/19/2012 21:01'!
removeNodeIndexes: indexName on: nodeId key: key value: value
	^ self portableUtil httpJsonDelete: (self rootUri, 'index/node/', indexName asString, '/', key asString, '/', value asString, '/', nodeId asString) ! !

!N4RestRawClient methodsFor: 'actions-indexes' stamp: 'mu 2/19/2012 16:32'!
removeRelationshipIndexes: indexName on: relId
	^ self portableUtil httpJsonDelete: (self rootUri, 'index/relationship/', indexName asString, '/', relId asString) ! !

!N4RestRawClient methodsFor: 'actions-indexes' stamp: 'mu 2/19/2012 21:01'!
removeRelationshipIndexes: indexName on: relId key: key
	^ self portableUtil httpJsonDelete: (self rootUri, 'index/relationship/', indexName asString, '/', key asString, '/', relId asString) ! !

!N4RestRawClient methodsFor: 'actions-indexes' stamp: 'mu 2/19/2012 21:01'!
removeRelationshipIndexes: indexName on: relId key: key value: value
	^ self portableUtil httpJsonDelete: (self rootUri, 'index/node/', indexName asString, '/', key asString, '/', value asString, '/', relId asString) ! !

!N4RestRawClient methodsFor: 'accessing' stamp: 'mu 12/2/2011 00:08'!
rootUri
	^ rootUri ifNil: [rootUri := self defaultRootUri]! !

!N4RestRawClient methodsFor: 'accessing' stamp: 'mu 12/2/2011 00:08'!
rootUri: anObject
	"Set the value of rootUri"

	rootUri := anObject! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:41'!
setProperties: properties nodeAt: nodeId
	| jsonString urlString |
	urlString := self rootUri , 'node/' , nodeId asString , '/properties'.
	jsonString := self portableUtil jsonStringFrom: properties.
	^ self portableUtil httpJsonPut: urlString content: jsonString ! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:10'!
setProperties: properties relationshipAt: relId
	| jsonString urlString |
	urlString := self rootUri , 'relationship/' , relId asString , '/properties'.
	jsonString := self portableUtil jsonStringFrom: properties.
	^ self portableUtil httpJsonPut: urlString content: jsonString ! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:30'!
setProperty: propName to: value nodeAt: nodeId 
	| jsonString urlString |
	urlString := self rootUri , 'node/' , nodeId asString , '/properties/', propName.
	jsonString := self portableUtil jsonStringFrom: value.
	^ self portableUtil httpJsonPut: urlString content: jsonString ! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/4/2011 15:29'!
setProperty: propName to: value relationshipAt: relId 
	| jsonString urlString |
	urlString := self rootUri , 'relationship/' , relId asString , '/properties/', propName.
	jsonString := self portableUtil jsonStringFrom: value.
	^ self portableUtil httpJsonPut: urlString content: jsonString ! !

!N4RestRawClient methodsFor: 'actions' stamp: 'mu 12/23/2011 12:42'!
traverseFrom: nodeId using: traversalDescription
	| jsonString urlString |
	urlString := self rootUri , 'node/' , nodeId asString, '/traverse/', traversalDescription returnType.
	jsonString := self portableUtil jsonStringFrom: traversalDescription asDictionary.
	^ self portableUtil httpJsonPost: urlString content: jsonString ! !

Object subclass: #N4Traversal
	instanceVariableNames: 'startNode db returnType order relationships uniqueness pruneEvaluator returnFilter maxDepth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Traversal'!

!N4Traversal class methodsFor: 'constants' stamp: 'mu 12/23/2011 11:51'!
builtInLanguageAssoc
	^'language' -> 'builtin'! !

!N4Traversal class methodsFor: 'constants' stamp: 'mu 12/23/2011 12:02'!
directionAllAssoc
	^'direction' -> 'all'! !

!N4Traversal class methodsFor: 'constants' stamp: 'mu 12/23/2011 12:02'!
directionInAssoc
	^'direction' -> 'in'! !

!N4Traversal class methodsFor: 'constants' stamp: 'mu 12/23/2011 12:02'!
directionOutAssoc
	^'direction' -> 'out'! !

!N4Traversal class methodsFor: 'instance creation' stamp: 'mu 1/22/2012 12:36'!
from: aNode
	^self new startNode: aNode; yourself! !

!N4Traversal class methodsFor: 'constants' stamp: 'mu 12/23/2011 11:52'!
javascriptLanguageAssoc
	^'language' -> 'javascript'! !

!N4Traversal class methodsFor: 'constants' stamp: 'mu 12/23/2011 11:55'!
nameAllAssoc
	^'name' -> 'all'! !

!N4Traversal class methodsFor: 'constants' stamp: 'mu 12/23/2011 11:56'!
nameAllButStartNodeAssoc
	^'name' -> 'all_but_start_node'! !

!N4Traversal class methodsFor: 'constants' stamp: 'mu 12/23/2011 11:55'!
nameNoneAssoc
	^'name' -> 'none'! !

!N4Traversal methodsFor: 'converting' stamp: 'mu 12/23/2011 12:45'!
asDictionary
	"order relationships uniqueness pruneEvaluator returnFilter maxDepth"
	| dict |
	dict := Dictionary new.
	self order ifNotNil: [dict at: 'order' put: self order].
	self relationships ifNotNil: [dict at: 'relationships' put: self relationships].
	self uniqueness ifNotNil: [dict at: 'uniqueness' put: self uniqueness].
	self pruneEvaluator ifNotNil: [dict at: 'pruneEvaluator' put: self pruneEvaluator].
	self returnFilter ifNotNil: [dict at: 'returnFilter' put: self returnFilter].
	self maxDepth ifNotNil: [dict at: 'maxDepth' put: self maxDepth].
	^dict! !

!N4Traversal methodsFor: 'accessing-convenient' stamp: 'mu 12/23/2011 11:20'!
breadthFirst
	self order: 'breadth_first'! !

!N4Traversal methodsFor: 'enumerating' stamp: 'mu 1/22/2012 14:42'!
collect: aBlock
	^ self traverse collect: aBlock! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 1/22/2012 12:35'!
db
	^self startNode db! !

!N4Traversal methodsFor: 'accessing-convenient' stamp: 'mu 12/23/2011 11:20'!
depthFirst
	self order: 'depth_first'! !

!N4Traversal methodsFor: 'enumerating' stamp: 'mu 1/22/2012 14:43'!
detect: aBlock ifNone: noneBlock
	^ self traverse detect: aBlock ifNone: noneBlock! !

!N4Traversal methodsFor: 'enumerating' stamp: 'mu 1/22/2012 14:32'!
do: aBlock
	^ self traverse do: aBlock! !

!N4Traversal methodsFor: 'enumerating' stamp: 'mu 1/22/2012 15:09'!
first
	^ self traverse first! !

!N4Traversal methodsFor: 'accessing-convenient' stamp: 'mu 1/22/2012 12:56'!
incoming: type
	self relIn: type! !

!N4Traversal methodsFor: 'testing' stamp: 'mu 1/22/2012 15:09'!
isEmpty
	^ self traverse isEmpty! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 12/23/2011 11:13'!
maxDepth
	"Answer the value of maxDepth"

	^ maxDepth! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 12/23/2011 11:13'!
maxDepth: anObject
	"Set the value of maxDepth"

	maxDepth := anObject! !

!N4Traversal methodsFor: 'accessing-convenient' stamp: 'mu 12/23/2011 12:08'!
noPrune
	self pruneEvaluator: (N4Dictionary with: self class builtInLanguageAssoc with: self class nameNoneAssoc)! !

!N4Traversal methodsFor: 'uniqueness' stamp: 'mu 12/23/2011 12:14'!
nodeGlobalUnique
	self uniqueness: 'node_global'! !

!N4Traversal methodsFor: 'uniqueness' stamp: 'mu 12/23/2011 12:14'!
nodePathUnique
	self uniqueness: 'node_path'! !

!N4Traversal methodsFor: 'uniqueness' stamp: 'mu 12/23/2011 12:16'!
nodeRecentUnique
	self uniqueness: 'node_recent'! !

!N4Traversal methodsFor: 'uniqueness' stamp: 'mu 12/23/2011 12:17'!
noneUnique
	self uniqueness: 'none'! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 12/23/2011 11:13'!
order
	"Answer the value of order"

	^ order! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 12/23/2011 11:13'!
order: anObject
	"Set the value of order"

	order := anObject! !

!N4Traversal methodsFor: 'accessing-convenient' stamp: 'mu 1/22/2012 12:56'!
outgoing: type
	self relOut: type! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 12/23/2011 11:13'!
pruneEvaluator
	"Answer the value of pruneEvaluator"

	^ pruneEvaluator! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 12/23/2011 11:13'!
pruneEvaluator: anObject
	"Set the value of pruneEvaluator"

	pruneEvaluator := anObject! !

!N4Traversal methodsFor: 'enumerating' stamp: 'mu 1/22/2012 14:42'!
reject: aBlock
	^ self traverse reject: aBlock! !

!N4Traversal methodsFor: 'accessing-convenient' stamp: 'mu 1/22/2012 15:55'!
relAll: type
	self relationships add: (N4Dictionary with: self class directionAllAssoc with: 'type' -> type)! !

!N4Traversal methodsFor: 'uniqueness' stamp: 'mu 12/23/2011 12:17'!
relGlobalUnique
	self uniqueness: 'relationship_global'! !

!N4Traversal methodsFor: 'accessing-convenient' stamp: 'mu 1/22/2012 15:55'!
relIn: type
	self relationships add: (N4Dictionary with: self class directionInAssoc with: 'type' -> type)! !

!N4Traversal methodsFor: 'accessing-convenient' stamp: 'mu 1/22/2012 15:55'!
relOut: type
	self relationships add: (N4Dictionary with: self class directionOutAssoc with: 'type' -> type)! !

!N4Traversal methodsFor: 'uniqueness' stamp: 'mu 12/23/2011 12:18'!
relPathUnique
	self uniqueness: 'relationship_path'! !

!N4Traversal methodsFor: 'uniqueness' stamp: 'mu 12/23/2011 12:18'!
relRecentUnique
	self uniqueness: 'relationship_recent'! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 1/22/2012 15:56'!
relationships

	^ relationships ifNil: [relationships := OrderedCollection new]! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 12/23/2011 11:13'!
relationships: anObject
	"Set the value of relationships"

	relationships := anObject! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 12/23/2011 11:13'!
returnFilter
	"Answer the value of returnFilter"

	^ returnFilter! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 12/23/2011 11:13'!
returnFilter: anObject
	"Set the value of returnFilter"

	returnFilter := anObject! !

!N4Traversal methodsFor: 'return types' stamp: 'mu 12/23/2011 11:25'!
returnFullpath
	self returnType: 'fullpath'! !

!N4Traversal methodsFor: 'return types' stamp: 'mu 12/23/2011 11:25'!
returnNode
	self returnType: 'node'! !

!N4Traversal methodsFor: 'return types' stamp: 'mu 12/23/2011 11:25'!
returnPath
	self returnType: 'path'! !

!N4Traversal methodsFor: 'return types' stamp: 'mu 12/23/2011 11:25'!
returnRelationship
	self returnType: 'relationship'! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 12/23/2011 12:40'!
returnType
	 returnType ifNil: [self returnNode].
	^returnType! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 12/23/2011 11:13'!
returnType: anObject
	"Set the value of returnType"

	returnType := anObject! !

!N4Traversal methodsFor: 'enumerating' stamp: 'mu 1/22/2012 14:42'!
select: aBlock
	^ self traverse select: aBlock! !

!N4Traversal methodsFor: 'enumerating' stamp: 'mu 1/22/2012 15:09'!
size
	^ self traverse size! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 1/22/2012 12:18'!
startNode
	"Answer the value of startNode"

	^ startNode! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 1/22/2012 12:18'!
startNode: aNode
	startNode := aNode! !

!N4Traversal methodsFor: 'actions' stamp: 'mu 1/22/2012 12:45'!
traverse
	^self traverseFrom: self startNode! !

!N4Traversal methodsFor: 'actions' stamp: 'mu 1/22/2012 13:08'!
traverseFrom: aNode
	"to do - implementing traverser"
	| json |
	json := self db restClient traverseFrom: startNode id using: self.
	^N4Traverser json: json for: self! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 12/23/2011 11:13'!
uniqueness
	"Answer the value of uniqueness"

	^ uniqueness! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 12/23/2011 11:13'!
uniqueness: anObject
	"Set the value of uniqueness"

	uniqueness := anObject! !

!N4Traversal methodsFor: 'accessing-convenient' stamp: 'mu 12/23/2011 12:05'!
wantAll
	self returnFilter: (N4Dictionary with: self class builtInLanguageAssoc with: self class nameAllAssoc) ! !

!N4Traversal methodsFor: 'accessing-convenient' stamp: 'mu 12/23/2011 12:05'!
wantAllButStartNode
	self returnFilter: (N4Dictionary with: self class builtInLanguageAssoc with: self class nameAllButStartNodeAssoc) ! !

Object subclass: #N4Traverser
	instanceVariableNames: 'traversal json index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Traversal'!

!N4Traverser class methodsFor: 'instance creation' stamp: 'mu 1/22/2012 13:26'!
json: jsonObject for: traversal 
	^ self new json: jsonObject;
		 traversal: traversal;
		 yourself! !

!N4Traverser methodsFor: 'accessing' stamp: 'mu 2/13/2012 00:35'!
at: anInteger
	self index: anInteger.
	^ self next! !

!N4Traverser methodsFor: 'stream-like' stamp: 'mu 1/22/2012 13:27'!
atEnd
	^self index > self json size! !

!N4Traverser methodsFor: 'enumerating' stamp: 'mu 1/22/2012 14:34'!
collect: aBlock
	| ord |
	ord := OrderedCollection new: self json size.
	[self atEnd] whileFalse: [
		ord add: (aBlock value: self next)
	].
	^ord! !

!N4Traverser methodsFor: 'accessing' stamp: 'mu 1/22/2012 15:01'!
db
	^self traversal db! !

!N4Traverser methodsFor: 'enumerating' stamp: 'mu 1/22/2012 14:41'!
detect: aBlock ifNone: noneBlock
	[self atEnd] whileFalse: [ | elem |
		(aBlock value: (elem := self next)) ifTrue: [^elem]
	].
	^noneBlock value! !

!N4Traverser methodsFor: 'enumerating' stamp: 'mu 1/22/2012 14:31'!
do: aBlock
	[self atEnd] whileFalse: [
		aBlock value: self next
	]! !

!N4Traverser methodsFor: 'accessing' stamp: 'mu 1/22/2012 15:11'!
first
	self index: 1.
	^ self next! !

!N4Traverser methodsFor: 'accessing' stamp: 'mu 1/22/2012 15:19'!
firstOrNil
	self isEmpty ifTrue: [^nil].
	^ self first! !

!N4Traverser methodsFor: 'accessing' stamp: 'mu 1/22/2012 13:25'!
index
	"Answer the value of index"

	^ index ifNil: [index := 1]! !

!N4Traverser methodsFor: 'accessing' stamp: 'mu 1/22/2012 13:24'!
index: anObject
	"Set the value of index"

	index := anObject! !

!N4Traverser methodsFor: 'testing' stamp: 'mu 1/22/2012 15:10'!
isEmpty
	^self json isEmpty! !

!N4Traverser methodsFor: 'accessing' stamp: 'mu 1/22/2012 13:25'!
json
	"Answer the value of json"

	^ json! !

!N4Traverser methodsFor: 'accessing' stamp: 'mu 1/22/2012 13:25'!
json: anObject
	"Set the value of json"

	json := anObject! !

!N4Traverser methodsFor: 'stream-like' stamp: 'mu 1/22/2012 13:28'!
next
	| parsed |
	parsed := self parse: (self json at: self index).
	self index: self index + 1.
	^parsed! !

!N4Traverser methodsFor: 'private' stamp: 'mu 1/22/2012 14:59'!
parse: jsonElement
	self returnType = 'node' ifTrue: [^(N4Node json: jsonElement) db: self db].
	self returnType = 'relationship' ifTrue: [^(N4Relationship json: jsonElement for: self startNode) db: self db].
	
	self flag: 'todo'.
	"self returnType = 'path' ifTrue: [].
	self returnType = 'fullpath' ifTrue: []."
	! !

!N4Traverser methodsFor: 'enumerating' stamp: 'mu 1/22/2012 14:42'!
reject: aBlock
	| ord |
	ord := OrderedCollection new.
	[self atEnd] whileFalse: [ | elem |
		(aBlock value: (elem := self next)) ifFalse: [ord add: elem]
	].
	^ord! !

!N4Traverser methodsFor: 'accessing' stamp: 'mu 1/22/2012 14:29'!
returnType
	^self traversal returnType! !

!N4Traverser methodsFor: 'enumerating' stamp: 'mu 1/22/2012 14:40'!
select: aBlock
	| ord |
	ord := OrderedCollection new.
	[self atEnd] whileFalse: [ | elem |
		(aBlock value: (elem := self next)) ifTrue: [ord add: elem]
	].
	^ord! !

!N4Traverser methodsFor: 'accessing' stamp: 'mu 1/22/2012 15:10'!
size
	^self json size! !

!N4Traverser methodsFor: 'accessing' stamp: 'mu 1/22/2012 15:00'!
startNode
	^self traversal startNode! !

!N4Traverser methodsFor: 'accessing' stamp: 'mu 1/22/2012 13:25'!
traversal
	"Answer the value of traversal"

	^ traversal! !

!N4Traverser methodsFor: 'accessing' stamp: 'mu 1/22/2012 13:25'!
traversal: anObject
	"Set the value of traversal"

	traversal := anObject! !
N4PortableUtil initialize!
N4SqPortableUtil initialize!
